Status: Closed Start date: 13 Nov 2020

Priority: Normal Due date:  

Assignee: John Abbott % Done: 100%

Category: CoCoA-4 function to be added Estimated time: 1.49 hour

Target version: CoCoA-5.4.0 Spent time: 1.45 hour

Description

At the moment CoCoA-5 does not recognise the keyword xel for specifying a term order when defining a new ring.

Implement?

Related issues:

Related to CoCoA-5 - Slug #465: Emacs UI; remove cruft New 11 Mar 2014

History

#1 - 13 Nov 2020 11:19 - John Abbott

- Related to Slug #465: Emacs UI; remove cruft added

#2 - 13 Nov 2020 11:23 - John Abbott

The matter was raised by Bernhard Andraschko.  His argument is below:

Imagine you are new to Computer Algebra and want to try CoCoA.

One of the first things you look for is how to work with term orderings.

"Oh, there are plenty of them implemented. Hmm... Lex, DegLex, DegRevLex... why is Xel not implemented yet?

It must be very hard to do so!

... but it's so easy? Why didn't they implement it yet?

Is this software in such an early state of development that they didn't even have time to implement such a sim

ple thing yet???

Let's use Sage instead!" 

 

There is also the question of backward compatibility.

I am not enthusiastic about creating new keywords (since that can cause backward incompatibility), but I cannot imagine may people wanting to use

xel.

#3 - 26 Nov 2020 14:37 - Anna Maria Bigatti

- Status changed from New to In Progress
- Assignee set to Anna Maria Bigatti

- % Done changed from 0 to 10

Very good reasoning.

Indeed some researchers have opposite standards, calling lex (and degrevlex) what we call xel (and nothing).

(among which, T.Mora and W.Seiler, if I recall well).

It's just a matter of reversing the list of names, but one might be happier finding its standard orderings.

I could do it.  Maybe just in CoCoA-5, and using matrix ordering.

#4 - 26 Nov 2020 16:06 - John Abbott

- % Done changed from 10 to 20

One difference between QQ[x,y,z],xel and QQ[z,y,x],lex is that the order in which the idents are printed is different:

/**/ use QQ[x,y,z],xel;

/**/ x*y*z;

x*y*z

/**/ use QQ[z,y,x],lex;

/**/ x*y*z;

z*y*x

#5 - 26 Nov 2020 16:20 - John Abbott

Anna will impl in CoCoAlib, and then make accessible to CoCoA-5.

#6 - 22 Feb 2021 22:00 - John Abbott

- Assignee changed from Anna Maria Bigatti to John Abbott

- % Done changed from 20 to 60

Anna has too much else to do.  So I have knocked up a quick impl... brain off, just cut-and-paste... and hope!

Perhaps Bernhard can do some testing!  ;-)

The impl should be in the next interim release.

#7 - 22 Feb 2021 23:03 - John Abbott

- Status changed from In Progress to Feedback

- % Done changed from 60 to 90

I have added doc, but no tests (too lazy/tired).

#8 - 24 Sep 2021 22:37 - John Abbott

- Status changed from Feedback to Closed
- % Done changed from 90 to 100

- Estimated time set to 1.49 h
